/***********
* dataflow *
************

Copies lattice data in and out.

*/

#include "comext.h"
#include <stdio.h>

putdata(fd)
FILE *fd;
{
	int i,j;

        /* Write out spin configuration */
	fmulti(fd);
	for (i=1;i<=isiz;i++) {
	   cfwrite(&spin[i][1],sizeof(short),jsiz,fd);
	}
	printf("Backed up spins OK\n");
	fflush(stdout);
	cfwrite(&randx,sizeof(long),1,fd);
	
        /* Write out seeds and pointers */
	seed(0);
	printf("Backed up seeds and pointers OK\n");
	fflush(stdout);

	fsingl(fd);
	cfwrite(&beta,sizeof(float),1,fd);
	printf("Wrote beta = %f OK\n", beta);
	cfwrite(&totswps,sizeof(int),1,fd);
	printf("Wrote totswps = %d OK\n", totswps);
	fflush(stdout);

	return 0 ;
}


getdata(fd)
FILE *fd;
{
	int ret,i,j,numbad;
	long randseed;
	float oldbeta;
	short errorflag,badspin;

        /* Read in spin configuration */
	fmulti(fd);
	errorflag = FALSE;
	for(i=1;i<=isiz;i++) {
	    if((ret=fread(&spin[i][1],sizeof(short),jsiz,fd)) != jsiz) {
		errorflag = TRUE;
	    }
	}

	/* Check the spins to make sure they're all OK */
	numbad = 0;
	for (i=1;i<=isiz;i++) {
	for (j=1;j<=jsiz;j++) {
	   if ((spin[i][j] >= Q) || (spin[i][j] < 0)) {
	      badspin = spin[i][j];
	      numbad++;
	   }
	}}
	fmulti(stdout);
	if (errorflag) {
	   printf("Proc %d failed to read spin!!\n",procnum);
	}
	else if (numbad > 0) {
	   errorflag = TRUE;
	   printf("Proc %d has %d bad spins such as %d!!\n",
		  procnum,numbad,badspin);
	}
	fflush(stdout);
	fsingl(stdout);
	if (errorflag) {
	   abort(-2);
	}
	else {
	   printf("Read in spins OK\n");
	   fflush(stdout);
	}

	if((ret=fread(&randseed,sizeof(long),1,fd)) != 1) {
		errorflag = TRUE;
	        printf("Proc %d read %d longs instead of 1\n", procnum,ret);
		abort(-3);
	}

	/* Read in seeds and pointers */
	if (first == 2)    /* initialize rng */
	   initseed();
	else               /* read in seeds from previous run */
	   seed(1);
	printf("Read in seeds and pointers OK\n");
	fflush(stdout);

	fsingl(fd);
	fmulti(stdout);
	if((ret=fread(&oldbeta,sizeof(float),1,fd)) != 1) {
		errorflag = TRUE;
	        printf("read %d floats instead of 1\n", ret);
	}

	if((ret=fread(&totswps,sizeof(int),1,fd)) != 1) {
		errorflag = TRUE;
	        printf("read %d ints instead of 1\n", ret);
	}
	fflush(stdout);
	fsingl(stdout);

	if (errorflag) {
	   abort(-4);
	}
	else {
	   printf("read beta = %f OK\n", beta);
	   printf("read totswps = %d OK\n", totswps);
	   fflush(stdout);
	}
	if (beta != oldbeta) {
	   printf("WARNING - beta (%f) != oldbeta (%f)\n", beta, oldbeta);
	   fflush(stdout);
        }
 
	return 0 ;
}

